// Generated by CoffeeScript 1.6.3
(function() {
  var badges, eachr, utils;

  utils = require('./utils');

  eachr = require('eachr');

  badges = {
    sections: {
      travis: function(opts) {
        if (opts == null) {
          opts = {};
        }
        if (!opts.badges.travis || !opts.username || !opts.name) {
          return '';
        }
        return "[![Build Status](https://secure.travis-ci.org/" + opts.username + "/" + opts.name + ".png?branch=master)](http://travis-ci.org/" + opts.username + "/" + opts.name + " \"Check this project's build status on TravisCI\")";
      },
      npm: function(opts) {
        if (opts == null) {
          opts = {};
        }
        if (!opts.badges.npm || !opts.name) {
          return '';
        }
        return "[![NPM version](https://badge.fury.io/js/" + opts.name + ".png)](https://npmjs.org/package/" + opts.name + " \"View this project on NPM\")";
      },
      gittip: function(opts) {
        var url;
        if (opts == null) {
          opts = {};
        }
        if (!opts.badges.gittip) {
          return '';
        }
        url = "https://www.gittip.com/" + opts.badges.gittip + "/";
        return "[![Gittip donate button](http://badgr.co/gittip/bevry.png)](" + url + " \"Donate weekly to this project using Gittip\")";
      },
      flattr: function(opts) {
        var url;
        if (opts == null) {
          opts = {};
        }
        if (!opts.badges.flattr) {
          return '';
        }
        url = "http://flattr.com/thing/" + opts.badges.flattr;
        return "[![Flattr donate button](https://raw.github.com/balupton/flattr-buttons/master/badge-89x18.gif)](" + url + " \"Donate monthly to this project using Flattr\")";
      },
      paypal: function(opts) {
        var url;
        if (opts == null) {
          opts = {};
        }
        if (!opts.badges.paypal) {
          return '';
        }
        url = "https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=" + opts.badges.paypal;
        return "[![PayPayl donate button](https://www.paypalobjects.com/en_AU/i/btn/btn_donate_SM.gif)](" + url + " \"Donate once-off to this project using Paypal\")";
      }
    },
    getBadgesSection: function(opts) {
      var results;
      if (opts == null) {
        opts = {};
      }
      results = [];
      eachr(badges.sections, function(fn, name) {
        var result;
        result = fn.call(this, opts);
        if (result) {
          results.push(result);
        }
        return true;
      });
      return results.join('\n');
    }
  };

  module.exports = badges;

}).call(this);
